import * as mc from '@minecraft/server'
import * as ui from '@minecraft/server-ui'
mc.world.beforeEvents.chatSend.subscribe(chat => {
    var {
        message, sender: player
    } = chat
    if (!player.isOp()) return
    var [cmd, ...subcmd] = message.split(/\s+/g)
        if (cmd == "!setmana") {
            chat.cancel = true
            if (!subcmd[0]) {
                player.sendMessage(`§cPlayer Not Found`)
            } else {
                if (!subcmd[1]) {
                    player.sendMessage(`§cNo Mana Entered`)
                } else if (isNaN(Number(subcmd[1].replace("k","000").replace("m","000000")))) {
                    player.sendMessage(`§cMana is not a number. Please use a number`)
                } else {
                    switch (subcmd[0]) {
                        case '@a':
                            mc.world.getAllPlayers().forEach(plr => {
                                sb.setScore(plr,"mana",Number(subcmd[1].replace("k","000").replace("m","000000")))
                            })
                            break;
                        case '@s':
                            sb.setScore(player,"mana",Number(subcmd[1].replace("k","000").replace("m","000000")))
                            break;
                            case '@p':
                            sb.setScore(player,"mana",Number(subcmd[1].replace("k","000").replace("m","000000")))
                            break;
                        default:
                            sb.setScore(mc.world.getAllPlayers().find(plr => plr.name == subcmd[0]),"mana",Number(subcmd[1]))
                    }
                }
            }
        } else if (cmd == "!help") {
            chat.cancel = true
            player.sendMessage("\n\n§eThis Is Help Page For The Commands. \n§a!setmana <§bplayer name§a|§b@a§a|§b@s§a|§b@p§a> <§bmana§a:§gnumber§a> \n!getmana <§bplayer§a:§gname§a|§b@a§a|§b@s§a|§b@p§a>")
        } else if (cmd == "!getmana") {
            chat.cancel = true
            if (!subcmd[0]) {
                player.sendMessage(`§cPlayer Not Found`)
            } else {
                switch (subcmd[0]) {
                    case '@a':
                        mc.world.getAllPlayers().forEach(plr => player.sendMessage(`§e${plr.name}§r has mana:§b ${getMana(plr)}`))
                        break;
                    case '@s':
                        player.sendMessage(`You have mana: §b${getMana(player)}`)
                        break;
                    case '@p':
                        player.sendMessage(`§e${player.name}§r has mana:§b ${getMana(player)}`)
                        break;
                    default:
                        player.sendMessage(`§e${mc.world.getAllPlayers().find(plr => plr.name == subcmd[0]).name}§r has mana: §b${getMana(mc.world.getAllPlayers().find(plr => plr.name == subcmd[0]))}`)
                }
            }
        } else if (cmd == "!getScore") {
            player.sendMessage(`${sb.getScore(player,"mana")}`)
        }
})
function Scoreboard() {
    this.setObj = function(x, v) {
        var x1 = `sb:${x}`
        if (this.getObj(x)) {
            this.delObj(x)
            this.setObj(x, v)
        } else {
            mc.world.scoreboard.addObjective(x1, v)
        }
    }
    this.hasObj = function(x) {
        var x1 = `sb:${x}`
        if (this.getObj(x)) {
            return true

        } else {
            return false
        }
    }
    this.getObj = function(x) {
        var x1 = `sb:${x}`
        if (mc.world.scoreboard.getObjective(x1)) {
            return mc.world.scoreboard.getObjective(x1).displayName
        }
    }
    this.newObj = function(x, v) {
        if (this.getObj(x)) {
            throw new Error("Objective Already Exist. Error At newObj()")
            return
        }
        this.setObj(x, v)
    }
    this.setScore = function(player, objective, score) {
        if (this.getObj(objective)) {
            mc.world.getDimension("overworld").runCommandAsync(`scoreboard players set ${player.name} "sb:${objective}" ${Number(score)}`)
        }
    }
    this.getScore = function(player, objective) {
        var objective1 = `sb:${objective}`
        if (this.getObj(objective)) {
            var obj = mc.world.scoreboard.getObjective(objective1)
            var players = obj.getParticipants()
            for (var i = 0; i < players.length; i++) {
                var plr = players[i]
                var dname = plr.displayName
                if (dname == player.name) {
                    return obj.getScore(plr)
                }
            } 
            return 0
        } else {
            throw new Error("Objective Doesn't Exist. at getScore()")
        }
    }
    this.addScore = function(player, objective, score) {
        if (this.getObj(objective)) {
            mc.world.getDimension("overworld").runCommandAsync(`scoreboard players add ${player.name} "sb:${objective}" ${score}`)
        } else {
            throw new Error("Objevtive Doesn't Exist. at addScore()")
        }
    }
    this.delObj = function(x) {
        var x1 = `sb:${x}`
        mc.world.scoreboard.removeObjective(x1)
    }
}
var sb = new Scoreboard()
function setMana(numomana, player) {
    if (!sb.getObj("mana")) {
        sb.setObj("mana", "Mana")
    }
    sb.setScore(player, "mana", numomana)
}
function getMana(player) {
    if (!sb.getObj("mana")) {
        sb.setObj("mana", "Mana")
    }
    return sb.getScore(player, "mana") ?? "0"
}
mc.world.beforeEvents.itemUse.subscribe(evd => {
    var {
        itemStack: item, source: player
    } = evd
    var {
        x: x1, y: y1, z: z1
    } = player.getHeadLocation()
var block = player.getBlockFromViewDirection() 
if (!block) block = {
  location: {
      x: x1-5, 
      y: y1-5, 
      z: z1-5
  }
}
    var {
        x, y, z
    } = block.location
    var diff = Math.floor(Math.hypot(x1-x, y1-y, z1-z))
    mc.system.run(() => {
    if (item.typeId == "dhruva:aote") {
        var mna = Number(getMana(player))? Number(getMana(player)): 0
        if (mna >= 50) {
            if (diff <= 8) {
                var coords = rp(player,0,0,diff - 0.3)
                player.teleport(coords)
            } else {
               var coords = rp(player,0,0,8)
               player.teleport(coords)
            }
            setMana(mna - 50, player)
            player.playSound("mob.endermen.portal")

        player.runCommandAsync(`title @s actionbar §cMana: §b${getMana(player)}(-50)§r`)
        } else {
            player.runCommandAsync(`title @s actionbar §cNot Enough Mana!`)
            player.playSound("mob.shulker.teleport")
        }
    }
    })
})
mc.world.afterEvents.entityHit.subscribe(evd => {
    var {
        hitEntity,
        entity: player
    } = evd
    if (player.typeId == "minecraft:player") {
        if (!hitEntity) return
        var health = hitEntity.getComponent("health").current
        if (health <= 0) {
            var manaNum = Number(getMana(player))? Number(getMana(player)): 0
            setMana(manaNum + 25, player)
        player.runCommandAsync(`title @s actionbar §cMana: §b${getMana(player)}(+25)§r`)
        }
    }
})
function norm ({x,y,z},s) {
    let l = Math.hypot(x,y,z)
    return {
        x: s * (x/l),
        y: s * (y/l),
        z: s * (z/l)
    }
}

function xa ({x,y,z},s) {
    let m = Math.hypot( x,z )
    let a = {
        x: z,
        y: 0,
        z: -x
    }
    
    return norm(a,s)
}

function ya ({x,y,z},s) {
    let m = Math.hypot( x,z )
    
    let a = {
        x: (x/m) * -y,
        y: m,
        z: (z/m) * -y
    }
    
    return norm(a,s)
}

function za (a,s) {
    return norm(a,s)
} 


function rp (plr, xf, yf, zf) {
    let l = plr.getHeadLocation();
    let d = plr.getViewDirection();
    let xx = xa(d,xf)
    let yy = ya(d,yf)
    let zz = za(d,zf)
    
    return {
        x: l.x + xx.x + yy.x + zz.x,
        y: l.y + xx.y + yy.y + zz.y,
        z: l.z + xx.z + yy.z + zz.z
    }
}
mc.system.runInterval(() => {
    mc.world.getAllPlayers().forEach(plr => {
        plr.runCommandAsync(`title @s actionbar §cMana: §b${getMana(plr)}§r`)
    })
},20)